# -*- coding: utf-8 -*-

#   calcIng - just another scientific calculator for the daily use
#   Copyright (C) 2010 Sebastian G. Barthmes - sebastian.barthmes@googlemail.com
#	
#	This program is free software; you can redistribute it and/or modify it 
#	under the terms of the GNU General Public License as published by the Free Software Foundation; 
#	either version 3 of the License, or (at your option) any later version.
#	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
#	without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
#	See the GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License along with this program; if not, see http://www.gnu.org/licenses/


from PyQt4 import QtGui, QtCore
from math import *
import sys

#factorial function since it is not in math <2.6
def fac(x):
	x=int(x)
	res=x
	for n in range(x-1):
		res*=(n+1)
	return res


class Button(QtGui.QPushButton):
    def __init__(self,text):
        QtGui.QPushButton.__init__(self)
        self.setText(text)
        #self.setMaximumSize(1000,1000)

class InputField(QtGui.QTextEdit):
    def __init__(self):
        QtGui.QTextEdit.__init__(self)
        self.grabKeyboard()
        
class GUIControl(QtGui.QWidget):
	def __init__(self):
		QtGui.QWidget.__init__(self)
		self.setWindowTitle('calcIng')
		#self.setWindowIcon(QtGui.QIcon(''))
		
		self.inputfield=InputField()
		self.inputfield.installEventFilter(self)
		#self.connect(self.inputfield, QtCore.SIGNAL('calculate()'),self.calculate())
		
		self.outputfield=QtGui.QLineEdit()
		
		self.clearB=Button("clear")
		self.delB=Button("delete")
		
		self.lastResult="0.0"
		
		self.b1=Button("1")
		self.b2=Button("2")
		self.b3=Button("3")
		self.b4=Button("4")
		self.b5=Button("5")
		self.b6=Button("6")
		self.b7=Button("7")
		self.b8=Button("8")
		self.b9=Button("9")
		self.b0=Button("0")
		
		self.dotB=Button(".")
		self.floatingpB=Button("*10^x")
		self.lastResB=Button("Ans")
		
		self.connect(self.b1, QtCore.SIGNAL('clicked()'), self.ins1)
		self.connect(self.b2, QtCore.SIGNAL('clicked()'), self.ins2)
		self.connect(self.b3, QtCore.SIGNAL('clicked()'), self.ins3)
		self.connect(self.b4, QtCore.SIGNAL('clicked()'), self.ins4)
		self.connect(self.b5, QtCore.SIGNAL('clicked()'), self.ins5)
		self.connect(self.b6, QtCore.SIGNAL('clicked()'), self.ins6)
		self.connect(self.b7, QtCore.SIGNAL('clicked()'), self.ins7)
		self.connect(self.b8, QtCore.SIGNAL('clicked()'), self.ins8)
		self.connect(self.b9, QtCore.SIGNAL('clicked()'), self.ins9)
		self.connect(self.b0, QtCore.SIGNAL('clicked()'), self.ins0)
		self.connect(self.dotB, QtCore.SIGNAL('clicked()'), self.insDot)
		self.connect(self.floatingpB, QtCore.SIGNAL('clicked()'), self.insFP)
		self.connect(self.lastResB, QtCore.SIGNAL('clicked()'), self.insAns)
		
		self.addB=Button("+")
		self.substactB=Button("-")
		self.multiplyB=Button("*")
		self.divideB=Button("/")
		self.calculateB=Button("=")
		self.sinB=Button("sin(x)")
		self.cosB=Button("cos(x)")
		self.tanB=Button("tan(x)")
		self.asinB=Button("asin(x)")
		self.acosB=Button("acos(x)")
		self.atanB=Button("atan(x)")
		self.lbrB=Button("(")
		self.rbrB=Button(")")
		self.powB=Button("x^y")
		self.sqrtB=Button("sqrt(x)")
		self.piB=Button("pi")
		self.lnB=Button("log(x)")
		self.expB=Button("e^x")
		self.factorialB=Button("x!")
		self.squaredB=Button("x^2")
		self.radB=Button("rad(x)")
		self.degB=Button("deg(x)")
		
		self.connect(self.degB,QtCore.SIGNAL('clicked()'), self.insdeg)
		self.connect(self.radB,QtCore.SIGNAL('clicked()'), self.insrad)
		self.connect(self.squaredB, QtCore.SIGNAL('clicked()'), self.square)
		self.connect(self.factorialB, QtCore.SIGNAL('clicked()'), self.insfac)
		self.connect(self.lnB, QtCore.SIGNAL('clicked()'), self.insln)
		self.connect(self.expB, QtCore.SIGNAL('clicked()'), self.insExp)
		self.connect(self.piB, QtCore.SIGNAL('clicked()'), self.insPi)
		self.connect(self.addB, QtCore.SIGNAL('clicked()'), self.add)
		self.connect(self.substactB, QtCore.SIGNAL('clicked()'), self.substract)
		self.connect(self.multiplyB, QtCore.SIGNAL('clicked()'), self.multiply)
		self.connect(self.divideB, QtCore.SIGNAL('clicked()'), self.divide)
		self.connect(self.calculateB, QtCore.SIGNAL('clicked()'), self.calculate)
		self.connect(self.sinB, QtCore.SIGNAL('clicked()'), self.sinus)
		self.connect(self.cosB, QtCore.SIGNAL('clicked()'), self.cosinus)
		self.connect(self.tanB, QtCore.SIGNAL('clicked()'), self.tangens)
		self.connect(self.asinB, QtCore.SIGNAL('clicked()'), self.asinus)
		self.connect(self.acosB, QtCore.SIGNAL('clicked()'), self.acosinus)
		self.connect(self.atanB, QtCore.SIGNAL('clicked()'), self.atangens)
		self.connect(self.lbrB, QtCore.SIGNAL('clicked()'), self.leftbracket)
		self.connect(self.rbrB, QtCore.SIGNAL('clicked()'), self.rightbracket)
		self.connect(self.powB, QtCore.SIGNAL('clicked()'), self.power)
		self.connect(self.sqrtB, QtCore.SIGNAL('clicked()'), self.sqrt)
		self.connect(self.clearB, QtCore.SIGNAL('clicked()'), self.clearInputF)
		self.connect(self.delB, QtCore.SIGNAL('clicked()'), self.deleteInput)
		
		leftvbox = QtGui.QVBoxLayout()
		leftgrid = QtGui.QGridLayout()
		
		leftgrid.addWidget(self.sqrtB,0,0)
		leftgrid.addWidget(self.powB,0,2)
		leftgrid.addWidget(self.squaredB,0,1)
		leftgrid.addWidget(self.factorialB,0,3)
		
		leftgrid.addWidget(self.sinB,1,0)
		leftgrid.addWidget(self.cosB,1,1)
		leftgrid.addWidget(self.tanB,1,2)
		leftgrid.addWidget(self.radB,1,3)
		
		leftgrid.addWidget(self.asinB,2,0)
		leftgrid.addWidget(self.acosB,2,1)
		leftgrid.addWidget(self.atanB,2,2)
		leftgrid.addWidget(self.degB,2,3)
		
		leftgrid.addWidget(self.lnB,3,0)
		leftgrid.addWidget(self.expB,3,1)
		leftgrid.addWidget(self.piB,3,2)
		
		leftvbox.addWidget(self.inputfield)
		leftvbox.addWidget(self.outputfield)
		leftvbox.addLayout(leftgrid)
		
		rightgrid = QtGui.QGridLayout()
		rightgrid.addWidget(self.delB,0,3)
		rightgrid.addWidget(self.clearB,0,4)
		rightgrid.addWidget(self.b1,3,0)
		rightgrid.addWidget(self.b2,3,1)
		rightgrid.addWidget(self.b3,3,2)
		rightgrid.addWidget(self.b4,2,0)
		rightgrid.addWidget(self.b5,2,1)
		rightgrid.addWidget(self.b6,2,2)
		rightgrid.addWidget(self.b7,1,0)
		rightgrid.addWidget(self.b8,1,1)
		rightgrid.addWidget(self.b9,1,2)
		rightgrid.addWidget(self.b0,4,0)
		rightgrid.addWidget(self.dotB,4,1)
		rightgrid.addWidget(self.floatingpB,4,2)
		rightgrid.addWidget(self.lastResB,4,3)
		rightgrid.addWidget(self.lbrB,1,3)
		rightgrid.addWidget(self.rbrB,1,4)
		rightgrid.addWidget(self.multiplyB,2,3)
		rightgrid.addWidget(self.divideB,2,4)
		rightgrid.addWidget(self.addB,3,3)
		rightgrid.addWidget(self.substactB,3,4)
		rightgrid.addWidget(self.calculateB,4,4)
		
		hbox = QtGui.QHBoxLayout()
		hbox.addLayout(leftvbox)
		hbox.addLayout(rightgrid)

		self.setLayout(hbox)

		self.degrees=False        
		

	def eventFilter(self, obj, ev): # http://qt.nokia.com/doc/4.5/qobject.html#eventFilter
		if ev.type() == QtCore.QEvent.KeyPress: # List of events: http://qt.nokia.com/doc/4.5/qevent.html#Type-enum
			#print "Pressed key: " + str(ev.key()) + " in widget " + str(obj)
			key=ev.key()
			if key == QtCore.Qt.Key_Escape:
				self.clearInputF()
				QtGui.QWidget.eventFilter(self,  obj,  ev)
				return True
			elif key == QtCore.Qt.Key_Return or key== QtCore.Qt.Key_Enter:
				self.calculate()
				QtGui.QWidget.eventFilter(self,  obj,  ev)
				return True
			else:
				QtGui.QWidget.keyPressEvent(self, ev)
		
		QtGui.QWidget.eventFilter(self,  obj,  ev)
		return False 

	def insrad(self):
		self.inputfield.insertPlainText("radians(")

	def insdeg(self):
		self.inputfield.insertPlainText("degrees(")

	def square(self):
		self.inputfield.insertPlainText("**2")

	def insfac(self):
		self.inputfield.insertPlainText("fac(")

	def deleteInput(self):
		tmpstr=self.inputfield.toPlainText()
		tmpstr=tmpstr[:-1]
		self.inputfield.setText("")
		self.inputfield.insertPlainText(tmpstr)

	def insln(self):
		self.inputfield.insertPlainText("log(")
		
	def insExp(self):
		self.inputfield.insertPlainText("exp(")

	def insPi(self):
		self.inputfield.insertPlainText("pi")

	def ins1(self):
		self.inputfield.insertPlainText("1")

	def ins2(self):
		self.inputfield.insertPlainText("2")
		
	def ins3(self):
		self.inputfield.insertPlainText("3")
		
	def ins4(self):
		self.inputfield.insertPlainText("4")
		
	def ins5(self):
		self.inputfield.insertPlainText("5")
		
	def ins6(self):
		self.inputfield.insertPlainText("6")

	def ins7(self):
		self.inputfield.insertPlainText("7")
		
	def ins8(self):
		self.inputfield.insertPlainText("8")
		
	def ins9(self):
		self.inputfield.insertPlainText("9")
		
	def ins0(self):
		self.inputfield.insertPlainText("0")   

	def insDot(self):
		self.inputfield.insertPlainText(".") 
		
	def insFP(self):
		self.inputfield.insertPlainText("e") 
		
	def insAns(self):
		self.inputfield.insertPlainText(self.lastResult) 

	def clearInputF(self):
		self.inputfield.setText("")

	def add(self):
		self.inputfield.insertPlainText("+")
		
	def substract(self):
		self.inputfield.insertPlainText("-")
		
	def multiply(self):
		self.inputfield.insertPlainText("*")
		
	def divide(self):
		self.inputfield.insertPlainText("/")
		
	def leftbracket(self):
		self.inputfield.insertPlainText("(")

	def rightbracket(self):
		self.inputfield.insertPlainText(")")

	def power(self):
		self.inputfield.insertPlainText("**(")

	def sqrt(self):
		self.inputfield.insertPlainText(" sqrt(")

	def sinus(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" sin(radians(")
		else:
			self.inputfield.insertPlainText(" sin(")

	def cosinus(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" cos(radians(")
		else:
			self.inputfield.insertPlainText(" cos(")
		
	def tangens(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" tan(radians(")
		else:
			self.inputfield.insertPlainText(" tan(")
		
	def asinus(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" asin(radians(")
		else:
			self.inputfield.insertPlainText(" asin(")

	def acosinus(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" acos(radians(")
		else:
			self.inputfield.insertPlainText(" acos(")
		
	def atangens(self):
		if self.degrees==True:
			self.inputfield.insertPlainText(" atan(radians(")
		else:
			self.inputfield.insertPlainText(" atan(")


	def calculate(self):
		instr=self.int2float(str(self.inputfield.toPlainText()))
		
		try:
			exec("out="+instr)
		except SyntaxError:
			self.outputfield.setText("= Syntax Error!")
		except ValueError:
			self.outputfield.setText("= Value Error! Function not used properly!")
		except ZeroDivisionError:
			self.outputfield.setText("= Division by zero!")
		except NameError:
			self.outputfield.setText("= Function not found!")
		else:
			if out>=1.6e+16:
				out="+Inf (or too high)"
			elif out<=-1.6e+16:
				out="-Inf (or too low)"
			elif abs(out)<3e-16:
				out=0.0
			self.outputfield.setText("= "+str(out))
			self.lastResult=str(out)



	def int2float(self,text):
		n=0
		x=False
		while x==False:
			#print "!",n
			if n==len(text)-1 and not text[n].isdigit():
					x=True
					break
			
			if text[n].isdigit():
				jobdone=False         
				#finde das ende der Zahl
				for j in range(len(text[n:])):
					#print n+j
					if (n+j)==len(text)-1:
						#print "..!"
						if text[n+j].isdigit() and not "." in text[n:(n+j)]:
							text=text+"."
							x=True
							break
						#else:
						#    x=True
						#    break
					if not text[n+j].isdigit() and not text[n+j]==".":
						#print "...",n,j
						if not "." in text[n:(n+j)]:
							text=text[:(n+j)]+"."+text[(n+j):]
							n+=(j+1)
							jobdone=True                            
						else:
							#print "else"
							n+=j
							jobdone=True
						if text[n]=="e":
							n+=2
							for i in range(len(text[n:])):
								print n+i
								try:
									if not text[n+i].isdigit() or (n+i)==len(text)-1:
										n+=i+1
										break
								except IndexError:
									x=True
									break
						
						if jobdone==True:
							break
			else:
				n+=1     
			if n>len(text)-1:
				x=True
		print text
		return text
            
                            
                               



def main():
    app = QtGui.QApplication(sys.argv)
    gui = GUIControl()
    desktop=app.desktop()
    
    #gui.resize(800,480)
    gui.show()
    
    sys.exit(app.exec_())

if __name__ == "__main__":
    main()
